package xyz.etztech.mixtape.commands;

import org.apache.commons.lang.StringUtils;
import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import xyz.etztech.mixtape.Database;
import xyz.etztech.mixtape.Mixtape;
import xyz.etztech.mixtape.MixtapeUtil;

import java.util.Arrays;

public class CommandAlias implements CommandExecutor {

    Mixtape plugin;

    public CommandAlias(Mixtape plugin) {
        this.plugin = plugin;
    }

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
        if (!(sender instanceof Player)) {
            sender.sendMessage(ChatColor.RED + "This command is not supported in Console.");
            return true;
        }
        Player player = (Player) sender;
        if (!player.hasPermission("mixtape.alias.chat")) {
            player.sendMessage(ChatColor.RED + "You do not have permission to create chat aliases.");
            return true;
        }

        if (args.length < 2) {
            player.sendMessage(ChatColor.RED + "/alias <alias> <chat>");
            return true;
        }

        if (MixtapeUtil.isLimited(player)) {
            player.sendMessage(ChatColor.RED + "You have hit your limit of allowed aliases. Delete one and try again.");
            return true;
        }

        String alias = MixtapeUtil.stripSlash(args[0]);

        String command = StringUtils.join(Arrays.copyOfRange(args, 1, args.length), " ");

        Mixtape.getDatabase().insert(player.getUniqueId().toString(), alias, command, Database.AliasType.CHAT);
        player.sendMessage(ChatColor.GREEN + "Chat alias created.");

        return true;
    }
}
